#include "mymenuevent.h"

extern int keeposd;
extern time_t t;

myMenuEvent::myMenuEvent(myWhatsOnItem *Item):cOsdMenu(tr("Event"))
{
 item=Item;
 event=item->event;
 
 const cChannel *channel=item->channel;
 if(channel)
 {
  SetTitle(channel->Name());
  SetHelp(tr("Record"),NULL,NULL,tr("Switch"));
 }
}

void myMenuEvent::Display(void)
{
 cOsdMenu::Display();
 if(event)
 {
  DisplayMenu()->SetEvent(event);
  cStatus::MsgOsdTextItem(event->Description());
 }
 else
  DisplayMenu()->SetText(tr("no info"),0);
}

eOSState myMenuEvent::Switch(void)
{
 const cChannel *channel=item->channel;
 if(channel && cDevice::PrimaryDevice()->SwitchChannel(channel, true))return keeposd?osContinue:osEnd;
 Skins.Message(mtError, tr("Can't switch channel!"));
 return osContinue;
}

eOSState myMenuEvent::Record(void)
{
 cTimer *timer;

 if(event)
  timer=new cTimer(event);
 else
 {
  char *buffer;
  int starthh,startmm,stophh,stopmm;
  
  struct tm *tm_t=localtime(&t);
  
  sscanf(*TimeString(t),"%2d:%2d",&starthh,&startmm);
  sscanf(*TimeString(t+Setup.InstantRecordTime*60),"%2d:%2d",&stophh,&stopmm);
  
  asprintf(&buffer,"1:%d:%d:%d%d:%d%d:%d:%d:%s",item->channel->Number(),tm_t->tm_mday,starthh,startmm,stophh,stopmm,Setup.DefaultPriority,Setup.DefaultLifetime,item->channel->Name());
  
  timer=new cTimer(false,false);
  timer->Parse(buffer);
  free(buffer);
 }

 if(timer)
 {
  cTimer *t=Timers.GetTimer(timer);
  if(t)
  {
   delete timer;
   timer=t;
  }
  return AddSubMenu(new cMenuEditTimer(timer,!t));
 }

 return osContinue;
}

eOSState myMenuEvent::ProcessKey(eKeys Key)
{
 if(!HasSubMenu())
 {
  switch(Key)
  {
   case kUp|k_Repeat:
   case kUp:
   case kDown|k_Repeat:
   case kDown:
   case kLeft|k_Repeat:
   case kLeft:
   case kRight|k_Repeat:
   case kRight:
    DisplayMenu()->Scroll(NORMALKEY(Key)==kUp||NORMALKEY(Key)==kLeft,NORMALKEY(Key)==kLeft||NORMALKEY(Key)==kRight);
    cStatus::MsgOsdTextItem(NULL,NORMALKEY(Key)==kUp);
    return osContinue;
   default: break;
  }
 }
 
 eOSState state=cOsdMenu::ProcessKey(Key);

 if(state==osUnknown)
 {
  switch(Key)
  {
   case kRecord:
   case kRed:return Record();
   case kGreen:
   case kYellow:return osContinue;
   case kBlue:return Switch();
   case kOk:return osBack;
   default:break;
  }
 }
 return state;
}
